clc;
mode(-1)
funcprot(0);

getd('..\macros');
getd('..\macros\utils');

// Algorithms
printf('Reading testing data...\n')
printf('-----------------\n');
data = read('../demos/dryer.dat',-1,2);
printf('Testing data loaded...\n')
printf('-----------------\n');
bound = 650;
y = data(1:bound,2); u = data(1:bound,1); //identification data
yv = data(bound+1:$,2); uv = data(bound+1:$,1); //validation data

printf('Function calls...\n')
printf('-----------------\n');
na=3; nb=3; nk=0;
[m1,a,b,Data,vare] = arx(y,u,na,nb,nk,'LS');
[fit, ys] = valSim(a, b, yv, uv);
disp(fit,'LS. Fit Factor: ');

[m2,a,b,Data,vare] = arx(y,u,na,nb,nk,'TLS');
[fit, ys] = valSim(a, b, yv, uv);
disp(fit,'TLS. Fit Factor: ');

[m3,a,b,Data,vare] = arx(y,u,na,nb,nk,'RTLS');
[fit, ys] = valSim(a, b, yv, uv);
disp(fit,'RTLS. Fit Factor: ');
//[fit, ys] = valPred(a, b,[], yv, uv);

// Plots
printf('-----------------\n');
printf('Plotting graphs...\n')
printf('-----------------\n');
plot(yv);
plot(ys,'-r');
legend('Validation','Prediction');

// Test results
disp('--------------------TEST Result--------------------')
printf('Testing arx.sci...\n')
printf('-----------------\n');
if (fit > 0.5) & (fit <= 100)
  disp(fit,'fit factor:')
  disp('TEST Result: PASSED')
else
  disp('TEST Result: FAILED')
end;




