clc;
mode(-1)
funcprot(0);

getd('..\macros');

// Algorithms
printf('Creating testing data...\n')
printf('-----------------\n');
A = [0.8 1;0 0.6]; B = [0;1]; C = [1 0]; D = 0; x0 = [1;1]
sys = syslin('d',A,B,C,D,x0); // discrete-time LTI
u = rand(1,40);
y = lsim(sys,u)+rand(1,40)/10; //noisy response
printf('Function calls...\n')
printf('-----------------\n');
x0est = estimatex0(y,u,sys)

// TEST Results
disp('--------------------TEST Result--------------------')
printf('Testing estimatex0...\n')
printf('-----------------\n');
disp(A,'A=');
disp(B,'B=');
disp(C,'C=');
disp(D,'D=');
disp(x0est,'x0 estimate:');

if size(A,1)==size(x0est,1) & ~isempty(x0est)
  disp('TEST Result: PASSED') 
else
  disp('TEST Result: FAILED')
end
