clc;
mode(-1)
funcprot(0);

getd('..\macros');

// Algorithms
printf('Reading testing data...\n')
printf('-----------------\n');
data = read('../demos/dryer.dat',-1,2); //data = [u y]
y = data(1:400,2); u = data(1:400,1); //identification data
yv = data(401:$,2); uv = data(401:$,1); //validation data
printf('Function calls...\n')
printf('-----------------\n');
[m a b vare P] = rarx(y,u,3,3,2);
[fit, yp] = valPred(a, b, [], yv, uv);

// Plots
printf('Plotting graphs...\n')
printf('-----------------\n');
plot(yv);
plot(yp,'-r');
legend('Validation','Prediction')

// Test results
disp('--------------------TEST Result--------------------')
printf('Testing rarx.sci...\n')
printf('-----------------\n');
if (fit > 0.9) & (fit <= 100)
  disp(fit,'fit factor:')
  disp('TEST Result: PASSED')
else
  disp('TEST Result: FAILED')
end;

