clc;
mode(-1)
funcprot(0);

getd('..\macros');

// Algorithms
printf('Creating testing data...\n')
printf('-----------------\n');
time = [1 1 2 5 6 7 8 10];
meas = [5 5 10 25 30 35 40 50];
data = [time;meas];
printf('Function calls...\n')
printf('-----------------\n');
datnew = repairtime(data,1)

// Plots
printf('Plotting graphs...\n')
printf('-----------------\n');
plot(time, meas);
plot(datnew(1,:),datnew(2,:),'r');
legend('Original','Repaired data');

// TEST Results
disp('--------------------TEST Result--------------------')
printf('Testing repairtime.sci...\n')
printf('-----------------\n');
minmax = max(time) - min(time) + 1;
// for each time moment there must be just one data value after repairing
if (minmax==size(datnew,2))
  disp(minmax,'Expected repaired data length OK:')
  disp('TEST Result: PASSED')  
else
  disp(minmax,'Wrong expected repaired data length!:')
  disp(minmax,'Expected data length is: ')
  disp('TEST Result: FAILED')
end;

