clc;
mode(-1)
funcprot(0);

getd('..\macros');
getd('..\macros\utils');

// Algorithms
printf('Reading testing data...\n')
printf('-----------------\n');
data = read('../demos/dryer.dat',-1,2);
printf('Testing data loaded...\n')
printf('-----------------\n');
y = data(1:400,2); u = data(1:400,1); //identification data
yv = data(401:$,2); uv = data(401:$,1); //validation data

printf('Function calls...\n')
printf('-----------------\n');
na=3; nb=3; nk=0;

// Testing rtls function
N = size(y,1);
FI = zeros(N-max(na+1,nb+nk)+1, na+nb);
for q = 1:na
  i = na-q+1;
  FI(:, (i-1)+1 : i) = -y(max(na,nb+nk-1)-i+1 : N-i,:);
end
for q = 1:nb
  i = nb-q+1;
  FI(:, (i-1)+1+na : i+na) = u(max(na,nb+nk-1)-i-nk+2 : N-i-nk+1,:);
end

yir = y(max(na+1,nb+nk):$,:);
theta0 = FI \ yir; // initial estimate
a0 = [1 theta0(1:na,:)'];
b0 = [theta0(na+1:$,:)']; 
[fit0, ys0] = valSim(a0, b0, yv, uv);
disp(fit0);

L = 0.01*eye(size(FI,2),size(FI,2));
delta = 1;
tau = 5;
//[theta, thetas] = rtls(FI,yir,theta0);
[theta, thetas] = rtls(FI,yir,theta0,delta,tau,L); // define all tunning parameters delta,tau,L
aR = [1 theta(1:na,:)'];
bR = [theta(na+1:$,:)']; 

[fit, ysR] = valSim(aR, bR, yv, uv);
//[fit, ys] = valPred(aR, bR,[], yv, uv);

// Plots
figure
printf('Plotting graphs...\n')
printf('-----------------\n');
plot(yv);
plot(ysR,'-r');
legend('Validation','Prediction');

disp('--------------------TEST Result--------------------')
printf('Testing rtls.sci...\n')
printf('-----------------\n');
disp(fit,'fit factor:')
disp('TEST Result: PASSED')








