clc;
mode(-1);
funcprot(0);

getd('..\macros');
getd('..\macros\utils');

//---------------------Testing data---------------------
N = 2000;
bound = N/2;
na = 10;
nb = 5;
nk = 0;
// Fan and Plate process:
//a0 = [1 -1.25 0.4375 -0.3594 0.1719 0.3125 -0.2764 0.1360 -0.0769 0.0137]; 
//b0 = [1 0.25 -0.25];
a0 = [1 0.1 -0.2 0.04 -0.03 ]; 
b0 = [1 2 -0.04 -0.009];

u = rand(N,1,'normal'); // input
[yr] = lsim(a0,b0,u);
y = yr + sqrt(0.1)*rand(N,1,'normal');
yi = y(1:bound);
ui = u(1:bound);
yv = y(bound+1:$); uv = u(bound+1:$); // validation data


example = 1; // 1 = ARX, 2 = ARMAX

select example
case 1
//------------------ARX model estimate------------------
[marx,a1,b1,FI] = arx(yi,ui,na,nb,nk);
[marx.fit, ys] = valSim(a1, b1, yv, uv);

// Initial model
figure
plot(yv);
plot(ys,'r');
title(string(marx.fit),'fontsize',3);
//------------------ARX model reducing------------------
//mo = idmodel();
//mo.a = marx.a; mo.b = marx.b;
[m1,mstruc] = selstruc(marx,uv,yv,yi);

// Reduced model
[m1.fit, ys] = valSim(m1.a, m1.b, yv, uv);
figure
plot(yv);
plot(ys,'r');
title(string(m1.fit),'fontsize',3);


case 2
//------------------ARMAX model estimate------------------
nc = 10;
[marmax,a1,b1,FI] = armax(yi,ui,na,nb,nc,nk);
[marmax.fit, ys] = valPred(marmax.a, marmax.b, marmax.c, yv, uv);

// Initial model
figure
plot(yv);
plot(ys,'r');
title(string(marmax.fit),'fontsize',3);
//------------------ARMAX model reducing------------------
//mo2 = idmodel();
//mo2.a = marmax.a; mo2.b = marmax.b; mo2.c = marmax.c;
[m2,mstruc] = selstruc(marmax,uv,yv,yi);

// Reduced model
[m2.fit, ys] = valPred(m2.a, m2.b, m2.c, yv, uv);

figure
plot(yv);
plot(ys,'r');
title(string(m2.fit),'fontsize',3);

end // end select




/////////////////////////
//A =  [   1.    0.    0.    0.  
//  -1.    1.    0.    0.  
//    0.  -1.    0.    0.  
//    0.    0.    1.    0.  
//    0.    0.  -1.    1.  
//    0.    0.    0.  -1.  ];
//b = [1 0 0 1 0 0]'
//
//Y = yi(max(na+1,nb+nk):$,:);
//    THETA = diag(theta(2:$));
//    Q = 2*THETA*(FI)'*FI*THETA;
//    f = -2*THETA*FI'*Y;
//mstruc = nng(marx.Data, theta, Aconstr, bconstr, na, nb, [], nk, yi);
