clc;
mode(-1)
funcprot(0);

getd('..\macros');  
getd('..\macros\subspace');
getd('..\macros\utils');

// Algorithms
printf('Loading testing data...\n')
printf('-----------------\n');
data = read('../demos/dryer.dat',-1,2);
printf('Creating testing data...\n')
printf('-----------------\n');
y = data(1:400,2); u = data(1:400,1); //identification data
yv = data(401:$,2); uv = data(401:$,1); //validation data
printf('Function calls...\n')
printf('-----------------\n');
[m,A,B,C,D,K,R,x0,fit fitTable] = subspaceIdent(y,u,yv,uv,[6:8],[2:4],0,1); // nonzero D
//[A,B,C,D,K,R,x0,fit fitTable] = subspaceIdent(y,u,yv,uv,[6:8],[2:4],0,0); //zero D
printf('Function calls...\n')
printf('-----------------\n');
[yp x] = lsim(A-K*C,[K B-K*D],C,[zeros(size(D,1),size(yv,2)) D],[yv';uv'],x0); //prediction

// Plots
printf('Plotting graphs...\n')
printf('-----------------\n');
plot(yv);
plot(yp,'-r');
legend('Validation','Prediction');

// Test results
disp('--------------------TEST Result--------------------')
printf('Testing...\n')
printf('-----------------\n');
if (fit > 0.9) & (fit <= 1)
  disp(fit,'fit factor:')
  disp('TEST Result: PASSED')
else
  disp('TEST Result: FAILED')
end;
