clc;
mode(-1)
funcprot(0);

getd('..\macros');
getd('..\macros\utils');

// Algorithms
printf('Reading testing data...\n')
printf('-----------------\n');
data = read('../demos/dryer.dat',-1,2);
printf('Testing data loaded...\n')
printf('-----------------\n');
y = data(1:400,2); u = data(1:400,1); //identification data
yv = data(401:$,2); uv = data(401:$,1); //validation data

printf('Function calls...\n')
printf('-----------------\n');
na=3; nb=3; nk=0;
[a b Data vare] = arx(y,u,na,nb,nk); // defining Data matrix by the help of arx.sci
yir = y(max(na+1,nb+nk):$,:);

theta = tls(Data,yir);

aTLS = [1 -theta(1:na,:)'];
bTLS = [theta(na+1:$,:)'];

[fit, ysR] = valSim(aTLS, bTLS, yv, uv);
//[fit, ytls] = valPred(aTLS, bTLS,[], yv, uv);

// Plots
figure
printf('Plotting graphs...\n')
printf('-----------------\n');
plot(yv);
plot(ytls,'-r');
legend('Validation','Prediction');

disp('--------------------TEST Result--------------------')
printf('Testing rtls.sci...\n')
printf('-----------------\n');
if (fit > 0.5) & (fit <= 1)
  disp(fit,'fit factor:')
  disp('TEST Result: PASSED')
else
  disp('TEST Result: FAILED')
end;







