function [v] = myhouseholder(a)

// input:   a - vector with a \neq 0
// output:  v - Householder vector of x such that v_1 = 1

n = length(a);
v = a;
if (a(1) >= 0)
    pomb = a(1) + norm(a);
else
    pomb = a(1) - norm(a);
end
v(2:n) = 1/pomb * v(2:n);
v(1) = 1;

endfunction