function [A] = qrhouse(A)

// input:   A - (n x m) matrix 
// output:  A - matrix containing the necessary information of the Householder
//              vectors v in the lower triangle and R in the upper triangle

[n,m] = size(A);
for k = 1:min(n-1,m)
	v(k:n,1) = myhouseholder(A(k:n,k));
	A(k:n,k:m) = multhouseholder(A(k:n,k:m),v(k:n,1));
	A(k+1:n,k) = v(k+1:n,1);
end

endfunction