clear
clc
funcprot(0)
mode(-1)
printf('Executing macros...\n')
printf('-----------------\n');
cd('..\macros\');
exec('allexec.sce');

printf('Loading data ([time; temp1;temp2], expected sampling time = 180): ...\n')
cd('..\demos\');
load('dat.dat');
time = dat(1,:);
u = dat(2,:);
y = dat(3,:);
printf('Data loaded...\n');
printf('-----------------\n');
printf('Original data...\n');
printf('Number of missing values: %d\n',sum(isnan(dat)));

printf('-----------------\n');
printf('Removing redundant missing values (dat_red)...\n');
// removes redundant NaN caused by non buffered sampling
// expected sampling time = 180, treshold = 100
dat_red = nanredundant(dat, 180,100);
printf('Number of missing values: %d\n',sum(isnan(dat_red)));


printf('-----------------\n');
dat_rep = repairtime(dat_red,180);
printf('Time domain repaired (dat_rep)...\n');
printf('Number of missing values: %d\n',sum(isnan(dat_rep)));


printf('-----------------\n');
printf('Removing missing values (dat_int)...\n');
// linear interpolation (replaces NaN)
dat_int = nanhandle(dat_rep,2);
printf('Number of missing values (NaN handling completed):%d\n',sum(isnan(dat_int)));


printf('-----------------\n');
printf('Number of samples (original data): %d\n',size(dat,2))
printf('Number of samples (processed data): %d\n',size(dat_int,2))


printf('-----------------\n');
printf('Figures...\n');
figure(1)
plot((dat_int(1,:)-dat_int(1,1))/180,dat_int(2,:))
title('temperature 1')
xlabel('time [min]');ylabel('temp1 [C]')
figure(2)
plot((dat_int(1,:)-dat_int(1,1))/180,dat_int(3,:))
title('temperature 2')
xlabel('time [min]');ylabel('temp2 [C]')



