clc;
mode(-1);
funcprot(0);

getd('..\macros');
getd('..\macros\utils');

// Algorithms
printf('Reading testing data...\n')
printf('-----------------\n');
data = read('../demos/dryer.dat',-1,2);
printf('Testing data loaded...\n')
printf('-----------------\n');
y = data(1:400,2); u = data(1:400,1); //identification data
yv = data(401:$,2); uv = data(401:$,1); //validation data
printf('Function calls...\n')
printf('-----------------\n');

na=3; nb=3; nc=2; nk=2;

[m1 vare P] = armax(y,u,na,nb,nc,nk,'RLS');
[fit, yp] = valPred(m1.a, m1.b, m1.c, yv, uv);
disp(fit,'RLS: ');

//[m2 vare P] = armax(y,u,na,nb,nc,nk,'TLS');
//[fit, yp] = valPred(m2.a, m2.b, m2.c, yv, uv);
//disp(fit,'RLS initial estimate + TLS: ');
//
//[m3 vare P] = armax(y,u,na,nb,nc,nk,'RTLS');
//[fit, yp] = valPred(m3.a, m3.b, m3.c, yv, uv);
//disp(fit,'RLS initial estimate + RTLS: ');
//
//[m4 vare P] = armax(y,u,na,nb,nc,nk,'SID');
//[fit, yp] = valPred(m4.a, m4.b, m4.c, yv, uv);
//disp(fit,'SID + PEM: ');


// Plots
printf('Plotting graphs...\n')
printf('-----------------\n');
plot(yv);
plot(yp,'-r');
legend('Validation','Prediction');

// Test results
disp('--------------------TEST Result--------------------')
printf('Testing armax.sci...\n')
printf('-----------------\n');
disp(fit,'fit factor:')
disp('TEST Result: PASSED')

