clc;
mode(-1)
funcprot(0);

getd('..\macros');

// Algorithms
// @Test1
printf('Creating testing data...\n')
printf('-----------------\n');
yv=[0 1 2 3 4 5 6];
ys1=[1 3 12 54 1 0 43];
ys2=[0 1 2 3 4 5 6];
fit1 = fitFactor(ys1, yv)
// @Test2
fit2 = fitFactor(ys2, yv)
// @Test3
printf('Reading testing data...\n')
printf('-----------------\n');
data = read('../demos/dryer.dat',-1,2);
printf('Testing data loaded...\n')
printf('-----------------\n');
y = data(1:400,2); u = data(1:400,1); //identification data
yv = data(401:$,2); uv = data(401:$,1); //validation data
printf('Function calls...\n')
printf('-----------------\n');
[a, b, vare, P, fit] = arIdent(y,u,yv,uv,1:4,1:4,0,0:3,0); 
[fit3, yp] = valPred(a, b, [], yv, uv);


// Test Results
disp('--------------------TEST Result--------------------')

printf('Testing fitFactor.sci...\n')
printf('-----------------\n');
if (fit1 < 1)
  printf('@Test1: ')
  disp(fit1,'fitFactor([1 3 12 54 1 0 43],[0 1 2 3 4 5 6]) is ')
  disp('TEST Result: PASSED')
  printf('-----------------\n');
else
  disp('TEST Result: FAILED')
  printf('-----------------\n');
end;

printf('Testing fitFactor.sci...\n')
printf('-----------------\n');
if (fit2==1)
  printf('@Test2: ');
  disp(fit2,'fitFactor([0 1 2 3 4 5 6],[0 1 2 3 4 5 6]) is ')
  disp('TEST Result: PASSED')
  printf('-----------------\n');
else
  disp('TEST Result: FAILED')
  printf('-----------------\n');
end;

printf('Testing fitFactor.sci...\n')
printf('-----------------\n');
if (fit3<=1)
  printf('@Test3: ');
  disp(fit3,'fitFactor from arIdent.sci is ')
  disp('TEST Result: PASSED')
else
  disp('TEST Result: FAILED')
  printf('-----------------\n');
end;
