clc;
mode(-1)
funcprot(0);

getd('..\macros');

// Algorithms
printf('Creating testing data...\n')
printf('-----------------\n');
time = [0 27 28 29 30 58 59 60 89 90 91];
meas = [5 %nan %nan %nan 10 %nan 15 %nan  20 %nan 20];
data = [time;meas];
printf('Function calls...\n')
printf('-----------------\n');
datnew = nanredundant(data,30,5);

// Plots
printf('Plotting graphs...\n')
printf('-----------------\n');
//plot(time, meas);
plot(datnew(1,:),datnew(2,:),'r');
legend('Handled');

// Test results
disp('--------------------TEST Result--------------------')
printf('Testing nanredundant.sci...\n')
printf('-----------------\n');
printf('Number of missing values originally: %d\n',sum(isnan(meas)));
printf('-----------------\n');
suma=sum(isnan(datnew(2,:)));
printf('Number of missing values now: %d\n',suma);
printf('-----------------\n');

printf('Number of samples (original data): %d\n',size(meas,2))
printf('Number of samples (processed data): %d\n',size(datnew,2))

disp('TODO...')
// TODO

if suma==0
  disp('TEST Result: PASSED')
else
  disp('TEST Result: FAILED')
end;


