clc;
mode(-1);
funcprot(0);

getd('..\macros');
getd('..\macros\utils');
getd('..\macros\subspace');

// Choose an example (example = 1,2,...)
example = 2;

select example 
case 1
// ************************** Ball and Beam **************************
m = 0.111;
R = 0.015;
g = -9.8;
J = 9.99e-6;
H = -m*g/(J/(R^2)+m);
// Known form of matrices
Ai=[0 1 0 0
   0 0 H 0
   0 0 0 1
   0 0 0 0];
Bi=[0;0;0;1];
Ci=[1 0 0 0];
Di=[0];
A = [    0    1.0000         0         0
         0         0    1.0000         0
         0         0         0    1.0000
   -1.1036e-006   -0.0023   -1.6033   -0.2842]
B = 1.0e+004 *[-3.3533
    1.6008
    0.6834
   -2.7531];
C = [1  0  0  0];
D = [0];


//A = [    0.0008   -0.0001    0.0000    0.0000
//    0.0019    0.0006    0.0009    0.0007
//    0.0009    0.0005    0.1239   -1.5955
//   -0.0010   -0.0007    1.0362   -0.4066];
//B = [-9.4605e-007
//    0.0000
//    0.0149
//    0.0670];
//C = 1.0e+006 *[ 8.5414    0.0001   -0.0000   -0.0000]
//D = 0;



[m,An,Bn,Cn,Dn,T,e] = physical(A, B, C, D, A0, B0, C0, D0);

// Required Structure of matrices (there are 5 parameters to estimate)
A0 = [0 1 0 0; 0 0 %inf 0; 0 0 0 1; 0 0 0 0];
B0 = [0; 0; 0; 1];
C0 = [1 0 0 0];
D0 = [0];

[m,An,Bn,Cn,Dn,T,e] = physical(A, B, C, D, A0, B0, C0, D0);


    
case 2
// ***************************** EXAMPLE 2 *****************************
// Estimate Physical Parameters by BLACK-BOX Modeling - Ex.
// Inverted pendulum:
A = [-18.4268 30.1636 -15.0469 3.3101;
       -3.3101 -5.0311 9.9923 -1.6512;
       1.6512 -9.9923 5.0311 3.3101;
       -3.3101 15.0496 -30.1636 18.4268];
B = [-2.5304; 0.8296; -0.8214; 2.4391];
C = 1e-003*[0.8118 -0.8301 -0.88 0.8282];
D = [0];

// Required Structure of matrices
A0 = [0 1   0   0; 0 0  %inf  0; 0 0   0   1; 0 0  %inf  0];
B0 = [0; %inf; 0; %inf];
C0 = [1.5 0 0 0];
D0 = [0];

// Choose initial values of  %inf values in A0, B0, C0
m = 1; M = 7; l = 2; g = 10; // known physical parameters
ini1 = -2*m*g/(2*M+m);
ini2 = 2*g*(M+m)/((2*M+m)*l);
ini3 = 2/(2*M+m);
ini4 = -1/((2*M+m)*l);
initial = [ini1 ini2 ini3 ini4];

emax = 0.0000001;
[m,An,Bn,Cn,Dn] = physical(A, B, C, D, A0, B0, C0, D0, initial,emax)
//[An,Bn,Cn,Dn] = physical(A, B, C, D, A0, B0, C0, D0, initial)
//[An,Bn,Cn,Dn] = physical(A, B, C, D, A0, B0, C0, D0)

case 3
    // ***************************** EXAMPLE 3 *****************************
Ai = [0.9 0 0; 0 0.8 0; 0 0 0.5];
Bi = [1; -1; -2];
Ci = [1 0 0];
Di = [0];
u = rand(2000,1,'normal'); // input
yr = lsim(Ai,Bi, Ci, Di, [u]);
//plot(yr)
y = yr + sqrt(0.01)*rand(2000,1,'normal');
yi = y(1:1000); 
ui = u(1:1000); 
yv = y(1000+1:$);
uv = u(1000+1:$);
y = yi;
u = ui;

// Estimate
[msub,A,B,C,D] = subid(yi,ui,20,0,3); 
y = lsim(A, B, C, D, uv)
plot(y)

// Required Structure of matrices (there are 3 parameters to estimate)
A0 = [%inf 0; %inf %inf];
B0 = [1; %inf];
C0 = [1 0];
D0 = [0];
m0 = idmodel();
m0.A = A0; m0.B = B0; m0.C = C0; m0.D = D0;

// Choose initial values of  %inf values in A0, B0, C0
initial = [-0.1 -0.2 -5 1];
emax = 0.009;
[m,An,Bn,Cn,Dn,T,e] = physical(msub.A, msub.B, msub.C, msub.D, m0.A, m0.B, m0.C, m0.D);

yn = lsim(m.A,m.B,m.C,m.D,uv);
[m.fit] = fitFactor(yn, yv);
figure
plot(yn,'r');
plot(yv);
legend('yv','yn');
disp(m.fit,'FIT');



end