clc;
mode(-1);
funcprot(0);

getd('..\macros');
getd('..\macros\utils');
getd('..\macros\subspace');

// Algorithms
printf('-----------------\n');
printf('Reading testing data...\n')
printf('-----------------\n');

// Testing example 1
data = read('../demos/dryer.dat',-1,2); //data = [u y]
bound = 400;
y = data(1:bound,2); u = data(1:bound,1); //identification data
yv = data(bound+1:$,2); uv = data(bound+1:$,1); //validation data

na = 3; nb = 3; nc = 2; nk = 2; i=10;

printf('-----------------\n');
printf('Function calls...\n')
printf('-----------------\n');

m = substruc(y,u,i,na,nb,nc,nk);

[fit, yp] = valPred(m.a, m.b, m.c, yv, uv);
disp(fit,'PEM ARMAX estimate from initial subspace estimate. Fit factor: ');

// Plots
figure
printf('-----------------\n');
printf('Plotting graphs...\n')
printf('-----------------\n');
plot(yv);
plot(yp,'-r');
legend('Validation','Prediction');





















