clc;
mode(-1)
funcprot(0);

getd('..\macros');

// Algorithms
printf('Creating testing data...\n')
printf('-----------------\n');
data = read('../demos/dryer.dat',-1,2); //data = [u y]
printf('Testing data loaded...\n')
printf('-----------------\n');
y = data(1:400,2); u = data(1:400,1); //identification data
yv = data(401:$,2); uv = data(401:$,1); //validation data
printf('Function calls...\n')
printf('-----------------\n');
[a b c vare P] = armax(y,u,3,3,2,2);
// Calling Sequence
//  [fit, y] = validate(A,B,C,D,yv,uv,sp)
//  [fit, y] = validate(a,b,c,yv,uv,sp)
//  [fit, y] = validate(a,b,yv,uv,sp)

// TODO...
printf('Function calls...\n')
printf('-----------------\n');
[fits, ys] = validate(a, b, c, yv, uv, 1); //simulation
[fitp, yp] = validate(a, b, c, yv, uv, 0); //prediction

// Plots
printf('Plotting graphs...\n')
printf('-----------------\n');
plot(yv);
plot(yp,'--g');
plot(ys,'-r');

// TEST Results
disp('--------------------TEST Result--------------------')
printf('Testing validate.sci...\n')
printf('-----------------\n');
if (fits > 0.84 & fitp > 0.95)
  printf('TEST RESULT: PASS')
else
  printf('Fitfactor mismatch.\n')
  printf('TEST RESULT: FAIL\n')
end
